// Ambience
// code by jph

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

class Ambience
extends Remote
{	
	static final int FRM_W=1272;
  static final int FRM_H=1024;	
  static final int IMG_T=8;
	
  JFrame myJFrame;
  Container myContainer;
  JComponent myJComponent;
  String[] myPhotos;
	BufferedImage myBufferedImage;		
	String myAddress="http://www.fotocommunity.de/pc/pc/channel/2/extra/new/display/10675394";
	boolean myBoolean;
		
	Ambience(Terminal myTerminal,boolean myBoolean) {
		int c1;		
		this.myTerminal=myTerminal;
		this.myBoolean=myBoolean;
		File myFile=new File("photos/.");
    myPhotos=myFile.list();
    for (c1=0;c1<myPhotos.length;c1++)
      System.out.println(myPhotos[c1]);	  
		myJFrame=new JFrame("");
  	myContainer=new Container();
  	myContainer.setLayout(new BorderLayout());  	
  	myJComponent=new JComponent() {
	    public void paintComponent(Graphics myGraphics) {  	    
  	    if (myBufferedImage!=null) {
  	      myGraphics.setColor(new Color(0,0,0));
  	      myGraphics.fillRect(1272,0,8,1024);    	    
  	      myGraphics.drawImage(myBufferedImage,0,0,this);
	      }
	    }
    };
    myJComponent.repaint();
    myContainer.add("Center",myJComponent);
		myJFrame.getContentPane().add(myContainer);
		myJFrame.setLocation(0,0);
    myJFrame.setSize(FRM_W+8,FRM_H+27);
    myJFrame.setVisible(true);		
	  myThread=new Thread(this);
	  myThread.start();
	}
	
	public void run() {
		int c1,c2,c3,c4;
  	int index=0;
		int cnt=0;
		int pic_w,pic_h,pic_o;
		int cur_r=0;
		int cur_g=0;
		int cur_b=0;
		int[] myInt=new int[FRM_W*FRM_H]; // target image		
		int[] myImg=new int[FRM_W*FRM_H]; // image in view		
		int[] interp_r=new int[IMG_T];
		int[] interp_g=new int[IMG_T];
		int[] interp_b=new int[IMG_T];
		String myString;
		Random myRandom=new Random(System.currentTimeMillis());
		TreeMap myTreeMap=new TreeMap();
		Image myImage;
		myBufferedImage=new BufferedImage(FRM_W,FRM_H,BufferedImage.TYPE_INT_RGB);
		URL mySeed=null;
		URL myURL=null;
		try {
		  mySeed=new URL(myAddress);
	  } catch(MalformedURLException myMalformedURLException) {
      System.out.println(myMalformedURLException);
    }
		while (myTerminal.isLaunched) {
  		System.out.println("load");
      ImageInfo myImageInfo=new ImageInfo();
      try {
        if (myBoolean)
          myImageInfo.setInput(new FileInputStream("photos/"+myPhotos[index]));
        else {
          URLConnection myURLConnection;
          DataInputStream myDataInputStream;     
          myURLConnection=mySeed.openConnection();
          myURLConnection.setDoInput(true);
          myURLConnection.setUseCaches(false);      
          myDataInputStream=new DataInputStream(myURLConnection.getInputStream());
          while (true) {
            myString=myDataInputStream.readLine();
            if (myString==null)
              break;
            index=myString.indexOf("weiter</a>");
            if (0<index) {
              index=myString.indexOf("http://www.fotocommunity.de/pc/pc/channel/2/extra/new/display/",index);
              myAddress=myString.substring(index,myString.indexOf('"',index));
              mySeed=new URL(myAddress);
              System.out.println("seed : "+myAddress);
            }
            index=myString.indexOf("http://img.fotocommunity.com/photos/");
            if (0<index) {
              myAddress=myString.substring(index,myString.indexOf(".jpg",index)+4);
              System.out.println("photo: "+myAddress);
              myURL=new URL(myAddress);
              break;
            }
          }
          myURLConnection=myURL.openConnection();
          myURLConnection.setDoInput(true);
          myURLConnection.setUseCaches(false);
          myDataInputStream=new DataInputStream(myURLConnection.getInputStream());        
          myImageInfo.setInput((InputStream)myDataInputStream);
        }
      } catch(FileNotFoundException myFileNotFoundException) {
        System.out.println(myFileNotFoundException);
      } catch(MalformedURLException myMalformedURLException) {
        System.out.println(myMalformedURLException);
      } catch(IOException myIOException) {
        System.out.println(myIOException);
      }
      myImageInfo.check();
      pic_w=myImageInfo.getWidth();
      pic_h=myImageInfo.getHeight();
      System.out.println("original: "+pic_w+"x"+pic_h);
      myImage=null;
      if (myBoolean)
        myImage=myJFrame.getToolkit().getImage("photos/"+myPhotos[index]);
      else
        myImage=myJFrame.getToolkit().getImage(myURL);
      MediaTracker myMediaTracker=new MediaTracker(myJFrame); 	
      myMediaTracker.addImage(myImage,0);
      try {
        myMediaTracker.waitForAll();
      } catch (InterruptedException myInterruptedException) {
        System.out.println(myInterruptedException);
      }

      float scl=Math.min(FRM_W/(float)pic_w,FRM_H/(float)pic_h);
      pic_w=(int)Math.floor(pic_w*scl);
      pic_h=(int)Math.floor(pic_h*scl);
      pic_o =(FRM_H-pic_h)/2;
      pic_o*= FRM_W;
      pic_o+=(FRM_W-pic_w)/2;
      System.out.println("scale to: "+pic_w+"x"+pic_h);
      myImage=myImage.getScaledInstance(pic_w,pic_h,Image.SCALE_DEFAULT);  
      for (c1=0;c1<myInt.length;c1++) // is this necessary???
        myInt[c1]=0;
      PixelGrabber myPixelGrabber=new PixelGrabber(myImage,0,0,pic_w,pic_h,myInt,pic_o,FRM_W);
      try {
        myPixelGrabber.grabPixels();
      } catch (InterruptedException myInterruptedException) {
        System.out.println(myInterruptedException);
      }
      long col_r=0,col_g=0,col_b=0;
      long sum=1;
      float mean;
      for (c1=0;c1<pic_w*pic_h;c1++) {
        mean=RGBmean(myInt[c1]);
        if (1<mean&&mean<254) {
          col_r+=myInt[c1]>>16&0xff;
          col_g+=myInt[c1]>> 8&0xff;
          col_b+=myInt[c1]    &0xff;
          sum++;
        }
      }
      col_r/=sum;
      col_g/=sum;
      col_b/=sum;
      System.out.println(col_r+" "+col_g+" "+col_b+" of "+sum+" "+pic_w*pic_h);
      double fac=1./IMG_T;
      double lam=0;
      for (c1=0;c1<IMG_T;c1++) {
        lam+=fac;        
        interp_r[c1]=(int)(col_r*lam+cur_r*(1-lam));
        interp_g[c1]=(int)(col_g*lam+cur_g*(1-lam));
        interp_b[c1]=(int)(col_b*lam+cur_b*(1-lam));
      }
      cur_r=(int)col_r;
      cur_g=(int)col_g;
      cur_b=(int)col_b;
   		while (myTreeMap.size()<FRM_W)
    		myTreeMap.put(new Float(myRandom.nextFloat()),new Integer(myTreeMap.size()));
      Iterator myIterator=myTreeMap.values().iterator();      
      cnt=FRM_W/IMG_T;
      for (c1=0;c1<IMG_T;c1++) {
        Calibrate.setColor(interp_r[c1],interp_g[c1],interp_b[c1]);
        for (c2=0;c2<cnt;c2++)
          for (c3=((Integer)myIterator.next()).intValue();c3<FRM_W*FRM_H;c3+=FRM_W)
            myImg[c3]=myInt[c3];
        myBufferedImage.setRGB(0,0,FRM_W,FRM_H,myImg,0,FRM_W);        
        myJComponent.repaint();
        try {
          myThread.sleep(5);
			  } catch (InterruptedException myInterruptedException) {
			  	System.out.println(myInterruptedException);
			  }
		  }
		  myTreeMap.clear();
      try {
				myThread.sleep(3000);
			} catch (InterruptedException myInterruptedException) {
				System.out.println(myInterruptedException);
			}
  		index++;
  		index%=myPhotos.length;
		}
  }	
  
  static float RGBmean(int myInt) {
    int col_r=myInt>>16&0xff;
    int col_g=myInt>> 8&0xff;
    int col_b=myInt    &0xff;
    return (col_r+col_g+col_b)*.333333f;
  }

}

