// Calibrate
// code by jph

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

class Calibrate
extends Remote
implements ChangeListener
{
	static final int COL_W=30;
	static final int COL_H=250;
  
	JSlider[] myJSlider;
	JTextField[] myJTextField;	
	JComponent myJComponent;
	ImageIcon[] myImageIcon;
	Color myColor;
	static double col_r=0;
	static double col_g=0;
	static double col_b=0;
	
	Calibrate(Terminal myTerminal) {
		int c1;
		String myString;
		this.myTerminal=myTerminal;
		myJSlider=new JSlider[3];
		myJTextField=new JTextField[3];
		myImageIcon=new ImageIcon[3];
		myImageIcon[0]=new ImageIcon("res/icon.bbr.gif");
		myImageIcon[1]=new ImageIcon("res/icon.bbg.gif");
		myImageIcon[2]=new ImageIcon("res/icon.bbb.gif");
		JPanel myJPanel;
		myColor=new Color(0,0,0);
  	myJComponent=new JComponent() {
	    public void paintComponent(Graphics myGraphics) {  	    
  	    myGraphics.setColor(myColor);
  	    myGraphics.fillRect(0,0,COL_W,COL_H);
	    }
    };
    myJComponent.setMinimumSize(new Dimension(COL_W,COL_H));
    myJComponent.setPreferredSize(new Dimension(COL_W,COL_H));
		myTerminal.myContainer.add("West",myJComponent);		
		myJPanel=new JPanel();
		myJPanel.setLayout(new GridLayout(1,3,1,1));
  	for (c1=0;c1<3;c1++) {
		  myJSlider[c1]=new JSlider(JSlider.VERTICAL,0,255,0);		  
		  myJSlider[c1].setPaintLabels(true);
		  myJSlider[c1].setMajorTickSpacing(50);
		  myJSlider[c1].setMinorTickSpacing(25);
		  myJSlider[c1].setPaintTicks(true);
		  myJSlider[c1].addChangeListener(this);
		  myJPanel.add(myJSlider[c1]);
	  }
	  myTerminal.myContainer.add("Center",myJPanel);
		myJPanel=new JPanel();
		myJPanel.setLayout(new GridLayout(1,3,1,1));
		for (c1=0;c1<3;c1++) {
  		JPanel myJPamel=new JPanel();
  		myJPamel.setLayout(new FlowLayout());
      myJPamel.add(new JLabel(" ",myImageIcon[c1],JLabel.RIGHT));  		
		  myJTextField[c1]=new JTextField(4);		  
		  myJPamel.add(myJTextField[c1]);
		  myJPanel.add(myJPamel);
	  }
    myTerminal.myContainer.add("South",myJPanel);		
	  myTerminal.myJFrame.setSize(myTerminal.WIDTH,350);	  
	  myTerminal.myJFrame.validate();
		myTerminal.debug=0;
	  myThread=new Thread(this);
	  myThread.start();
	}
	
	static void setColor(int int_r,int int_g,int int_b) {
		byte[] myByte=new byte[4];
		myByte[0]=(byte)255;
		col_r=int_r;
		col_g=int_g;
		col_b=int_b;
		double col_x;
    col_r/=14.;
    col_g/=1.;
    col_b/=14.;
    col_x=Math.max(Math.max(col_r,col_g),col_b);
    if (col_x>0.01) {
      col_x=Math.sqrt(256/col_x);      
      col_r*=col_x;
      col_g*=col_x;
      col_b*=col_x;
    }
    System.out.println("("+int_r+","+int_g+","+int_b+") => ("+Math.round(col_r)+","+Math.round(col_g)+","+Math.round(col_b)+")");
		col_r=Math.max(254-col_r,0);
		col_g=Math.max(254-col_g,0);
		col_b=Math.max(254-col_b,0);
		myByte[1]=(byte)col_r;
		myByte[2]=(byte)col_g;
		myByte[3]=(byte)col_b;
		myTerminal.write(myByte);  	
	}
	
	public void stateChanged(ChangeEvent myChangeEvent) {
		int int_r=myJSlider[0].getValue();
		int int_g=myJSlider[1].getValue();
		int int_b=myJSlider[2].getValue();
    myColor=new Color(int_r,int_g,int_b);
    setColor(int_r,int_g,int_b);
 		myJTextField[0].setText(""+Math.round(col_r));
		myJTextField[1].setText(""+Math.round(col_g));
		myJTextField[2].setText(""+Math.round(col_b));
  	myJComponent.repaint();
		try {
			myThread.sleep(25);
		} catch (InterruptedException myInterruptedException) {
			System.out.println(myInterruptedException);
		}
  }
  
	public void run() {
		int c1,c2,c3=0;
		int clr,cnt=0;
		int[] myByte;
		int[] col=new int[3];
		double[] pre=new double[3];
		double max;				
		String gps;
		String myString;				
		while (myTerminal.isLaunched) {
			try {
				myThread.sleep(125);
			} catch (InterruptedException myInterruptedException) {
				System.out.println(myInterruptedException);
			}
		}
  }	

}
