// Terminal
// code by jph

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.comm.*;
import javax.swing.*;
import javax.swing.event.*;

public class Terminal
implements ActionListener,SerialPortEventListener
{
	static final String[] _TYPES={"Ambience","Community","Calibrate"};
	static final String[] _BAUDS={"9600","19200","38400"};
	static final int WIDTH=400;

	JFrame myJFrame;
	Container myContainer;
	Remote myRemote;
	
	JButton myJButton[];
	static final int START=0;
	static final int YIELD=1;
	
	JComboBox myJComboBox[];
	static final int TYPES=2;
	static final int PORTS=0;
	static final int BAUDS=1;

	volatile boolean isLaunched=false;	
	long atLaunch;
	static final int TIMEOUT_OPEN=2000;
	CommPortIdentifier myCommPortIdentifier;
  SerialPort mySerialPort;

  OutputStream myOutputStream;
  PrintWriter myPrintWriter;
	InputStream myInputStream;
	
	public static void main(String[] args) {
    Terminal myTerminal=new Terminal();
  }

  public Terminal() {
		myJFrame=new JFrame("Terminal");
		myJButton=new JButton[2];
		myJComboBox=new JComboBox[3];

  	myContainer=new Container();
  	myContainer.setLayout(new BorderLayout());
  		JToolBar myJToolBar=new JToolBar();
  				myJComboBox[TYPES]=new JComboBox(_TYPES);
  				myJComboBox[TYPES].setToolTipText("choose mission");
  				myJComboBox[TYPES].addActionListener(this);
  			myJToolBar.add(myJComboBox[TYPES]);
  			myJToolBar.addSeparator();
					myJComboBox[PORTS]=new JComboBox();
					myJComboBox[PORTS].setToolTipText("select serial port");
					Enumeration myEnumeration=CommPortIdentifier.getPortIdentifiers();
					while (myEnumeration.hasMoreElements()) {
					CommPortIdentifier myCommPortIdentifier=(CommPortIdentifier)myEnumeration.nextElement();
					if (myCommPortIdentifier.getPortType()==CommPortIdentifier.PORT_SERIAL)
						myJComboBox[PORTS].addItem(myCommPortIdentifier.getName());
				}
				myJComboBox[PORTS].addItem("void");
				myJComboBox[PORTS].addItem("void");
				myJComboBox[PORTS].addItem("void");
				myJToolBar.add(myJComboBox[PORTS]);
				myJToolBar.add(new JLabel(" "));
  				myJComboBox[BAUDS]=new JComboBox(_BAUDS);
  				myJComboBox[BAUDS].setToolTipText("choose baud rate of serial communication");  				
  			myJToolBar.add(myJComboBox[BAUDS]);
				myJToolBar.addSeparator();
				myJButton[START]=new JButton("Launch",new ImageIcon("res/icon.lc0.gif"));
   			myJButton[START].setToolTipText("launch mission");
   			myJButton[START].addActionListener(this);
   		myJToolBar.add(myJButton[START]);
				myJButton[YIELD]=new JButton("Stop",new ImageIcon("res/icon.lc1.gif"));
				myJButton[YIELD].setEnabled(false);
   			myJButton[YIELD].setToolTipText("terminate mission");
   			myJButton[YIELD].addActionListener(this);
   		myJToolBar.add(myJButton[YIELD]);
	  myContainer.add("North",myJToolBar);
	  
	  myJComboBox[TYPES].setSelectedIndex(1);
	  myJComboBox[PORTS].setSelectedIndex(0);
	  myJComboBox[BAUDS].setSelectedIndex(1);
	  
		myJFrame.getContentPane().add(myContainer);
		myJFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent myWindowEvent) { System.exit(0);}});
			
		myJFrame.setLocation(450,200);
    myJFrame.setSize(WIDTH,56);
    myJFrame.setVisible(true);
  }

	public void actionPerformed(ActionEvent myActionEvent) {
	  int c1=0,c2;
	  if (myActionEvent.getSource()==myJButton[START]||
	      myActionEvent.getSource()==myJButton[YIELD]) {
			myJComboBox[TYPES].setEnabled(isLaunched);
			myJComboBox[PORTS].setEnabled(isLaunched);
			myJComboBox[BAUDS].setEnabled(isLaunched);
			myJButton[START].setEnabled(isLaunched);
	  	isLaunched=!isLaunched;
	  	myJButton[YIELD].setEnabled(isLaunched);
	  	if (isLaunched) {
  	  	atLaunch=System.currentTimeMillis();
			  serialPortOpen();
			  if ("Ambience".equals(myJComboBox[TYPES].getSelectedItem()))
			  	myRemote=new Ambience(this,true);
			  if ("Community".equals(myJComboBox[TYPES].getSelectedItem()))
			  	myRemote=new Ambience(this,false);
			  if ("Calibrate".equals(myJComboBox[TYPES].getSelectedItem()))
			  	myRemote=new Calibrate(this);			  	
  		} else {
	  		while (myRemote.myThread.isAlive()) ;
	  		serialPortClose();
				for (c1=1;c1<myContainer.getComponentCount();c1++) // this is new !
				  myContainer.remove(c1);				                   // this is new !
	  		myJFrame.setSize(WIDTH,56);
  		}
		}
		if (myActionEvent.getSource()==myJComboBox[TYPES]) {
			if ("Ambience".equals(myJComboBox[TYPES].getSelectedItem())) {
				myJComboBox[PORTS].setSelectedIndex(0);
				myJComboBox[BAUDS].setSelectedIndex(1);
			}
		}
	}

	/* serial communication */
	volatile byte[] buffer;
	public static final int MOD=2048;
	volatile int tail=0;
	volatile int head=0;
	int debug=0;

	void serialPortOpen() {
		int myInt=Integer.parseInt((String)myJComboBox[BAUDS].getSelectedItem());
		buffer=new byte[MOD];
		try {
			myCommPortIdentifier=CommPortIdentifier.getPortIdentifier((String)myJComboBox[PORTS].getSelectedItem());			
		} catch (NoSuchPortException myNoSuchPortException) {
			System.out.println(myNoSuchPortException);
		}
		try {
			mySerialPort=(SerialPort)myCommPortIdentifier.open("noname",TIMEOUT_OPEN);
			System.out.println("serial port "+myJComboBox[PORTS].getSelectedItem()+" open");
		} catch (PortInUseException myPortInUseException) {
			System.out.println(myPortInUseException);
		}
		System.out.println("baud rate "+myInt);
		try {
			mySerialPort.setSerialPortParams(myInt,//STARTBIT_1
			                                 SerialPort.DATABITS_8,
			                                 SerialPort.STOPBITS_1,
			                                 SerialPort.PARITY_NONE);
		} catch (UnsupportedCommOperationException myUnsupportedCommOperationException) {
			System.out.println(myUnsupportedCommOperationException);
		}
		mySerialPort.notifyOnDataAvailable(true);
		try {
			mySerialPort.addEventListener(this);
		} catch (TooManyListenersException myTooManyListenersException) {
			System.out.println(myTooManyListenersException);
		}		
		try {
			myOutputStream=mySerialPort.getOutputStream();
			myInputStream=mySerialPort.getInputStream();
    } catch (IOException myIOException) {
	    System.out.println(myIOException);
		}
		myPrintWriter=new PrintWriter(myOutputStream);		
	}
	
	void serialPortClose() {
		try {
			myOutputStream.flush();
			myOutputStream.close();
			myPrintWriter.flush();
			myPrintWriter.close();
			myInputStream.close();
			mySerialPort.close();
			System.out.println("serial port closed");
		} catch (IOException myIOException) {
			System.out.println(myIOException);			
		}
	}
	
	public synchronized void serialEvent(SerialPortEvent mySerialPortEvent) {
		int c1;
		int tmp;
		if (mySerialPortEvent.getEventType()==SerialPortEvent.DATA_AVAILABLE) {
			try {
				byte[] myByte=new byte[myInputStream.available()];
				myInputStream.read(myByte);
				for (c1=0;c1<myByte.length;c1++) {
					buffer[head]=myByte[c1];
					head++;
					head%=MOD;
					if (debug>2) {
						tmp=myByte[c1];
						if (myByte[c1]<0) tmp+=256;
						System.out.print(tmp+".");
					}
				}
				if (debug>2)
					System.out.println("");				
			} catch (IOException myIOException) {
				System.out.println(myIOException);
      }
    }
	}
	
	/* transmit */
	void write(byte[] myByte) {
		try {
			myOutputStream.write(myByte);
			myOutputStream.flush();
		} catch (IOException myIOException) {
			System.out.println(myIOException);
		}
	}

	void print(String myString) {
		myPrintWriter.print(myString);
		myPrintWriter.flush();
	}

	void println(String myString) {
		myPrintWriter.println(myString);
		myPrintWriter.flush();
	}

	/* receive */
	synchronized int[] read() {
		int c1,len;
		len=head-tail;
		if (len<0) len+=MOD;
		int[] myByte=new int[len];
		for (c1=0;c1<len;c1++) {
			myByte[c1]=buffer[(tail+c1)%MOD];
			if (myByte[c1]<0) myByte[c1]+=256;
		}
		//tail=head; // as an extra function after parsing
		if (debug>1&&len>0)
			System.out.println("read["+len+"]");
		return myByte;
	}

	synchronized void clear(int myInt) {
		tail+=myInt;
		tail%=MOD;
	}
	synchronized int length() {
  	return (head+MOD-tail)%MOD;  	  
	}

		
	synchronized void clear() {
  	if (debug>2)
  	  System.out.println("<"+(head+MOD-tail)%MOD+">");
		tail=head;
	}

	String format(int[] myByte) {
		int c1;
		String myString="";
		for (c1=0;c1<myByte.length;c1++)
			myString+=(char)myByte[c1];
		return myString;
	}	
}
